/******************************************************************************
 * monitor code generated by NuRV (NuRV_lite version: 1.0.0)
 *
 * LTL: (p U q)
 *
 * nbits_obs: 2 (width: 1), nbits_all: 2 (width: 1)
 * reset_table: 1, trans_table: 1, input_filter: 0
 ******************************************************************************/

#include <stdio.h>  /* for FILE, etc. */
#include <stddef.h> /* for size_t */
#include <stdlib.h> /* for bsearch() */
#include <stdint.h> /* for int8_t, etc. */
#include <string.h> /* for memset() */
#include <assert.h> /* for assert() */

#include "monitor.h"

/* maximum number of elements in each line: 20 */
static int reset_table[5] = {
  0, 1, 1, 1, 1
};

/* for internal per-monitor use only */
typedef struct {
  long input;
  int output;
  int next_loc;
} trans_t;

/* maximum number of elements in each line: 4 */
static trans_t data_4[2] = {
  {0x1L, 1, 4}, {0x2L, 1, 3}
};

static trans_t data_3[2] = {
  {0x1L, 1, 4}, {0x2L, 1, 3}
};

static trans_t data_2[2] = {
  {0x1L, 0, 2}, {0x2L, 1, 3}
};

static trans_t data_1[2] = {
  {0x1L, 0, 2}, {0x2L, 1, 3}
};

static int data_cmp (const void *lhs, const void *rhs)
{
  const trans_t *_lhs = (const trans_t *)lhs;
  const trans_t *_rhs = (const trans_t *)rhs;

  return (_lhs -> input - _rhs -> input);
}

static trans_t* data_table[5] = {
  NULL, data_1, data_2, data_3, data_4
};

/* number of elements in each line: 20 */
static size_t size_table[5] = {
  0, 2, 2, 2, 2
};

/* 3. main function (old API) */
int /* [out] (0 = unknown, 1 = true, 2 = false, 3 = error) */
  monitor
    (long state,       /* [in] */
     int  reset,       /* [in] (0 = none, 1 = hard, 2 = soft) */
     int *current_loc) /* [in/out] */
{
  long states[1], base = 1L;

  states[0] = (state % 2L) * base;
  state >>= 1;
  base <<= 1;
  states[0] += (state % 2L) * base;

  return monitor_ex (states, 1, reset, current_loc);
}

/* internal function (no input filtering) */
static RV_value monitor_internal
  (long    *inputs,      /* [in] */
   size_t   width,       /* [in] (min: 1) */
   RV_reset reset,       /* [in] */
   int     *current_loc) /* [in/out] */
{
  /* local variables */
  trans_t *table, key, *result; /* for bsearch() */
  size_t size;                  /* for bsearch() */
  RV_value output;

  /* validate inputs (part 1) */
  if (NULL == current_loc) {
    return RV_INVALID_LOC;
  }

  /* handle resets */
  if (HARD_RESET == reset) {
    *current_loc = 1; /* initial location */
  }

  /* validate inputs (part 2) */
  if (*current_loc <= 0 || *current_loc > 4) {
    return RV_INVALID_LOC;
  }
  if (width < 1) return RV_INVALID_ARG;

  if (SOFT_RESET == reset) {
    int i = *current_loc;
    *current_loc = reset_table[i];
  }

  /* perform binary search */
  table = data_table[*current_loc];
  size = size_table[*current_loc];
  if (0 == size) {
    result = NULL;
  } else {
    key.input = inputs[0];
    result = (trans_t *)bsearch(&key, table, size, sizeof(trans_t), data_cmp);
  }
  if (result) {
    output = result->output;
    *current_loc = result->next_loc;
  } else {
    output = RV_ERROR;
  }

  return output;
}

/* 4. main function (new API) */
RV_value monitor_ex
  (long    *states,      /* [in] */
   size_t   width,       /* [in] (min: 1) */
   RV_reset reset,       /* [in] */
   int     *current_loc) /* [in/out] */
{
  return monitor_internal(states, 1, reset, current_loc);
}

/* scalar support */
typedef struct {int key; int value;} scalar_t;

static int scalar_cmp (const void *lhs, const void *rhs)
{
  const scalar_t *_lhs = (const scalar_t *)lhs;
  const scalar_t *_rhs = (const scalar_t *)rhs;

  return (_lhs -> key - _rhs -> key);
}

/* 5. The scalar monitor interface */
RV_value monitor_scalar
  (monitor_input_t *input,
   monitor_mask_t *masks,
   RV_reset reset,
   int *current_loc)
{
  long inputs[1];
  scalar_t item, *result = NULL;
  int p = input->p;
  int q = input->q;
  int bit, bits;

  memset((void *)inputs, 0, 1 * sizeof(long));
  inputs[0] += (p) ? 0x1L : 0L;
  inputs[0] += (q) ? 0x2L : 0L;

  return monitor_internal(inputs, 1, reset, current_loc);
}
