/******************************************************************************
 * monitor code generated by NuRV (NuRV_lite version: 1.0.0)
 *
 * LTL:  G (p ->  X ( X q))
 *
 * nbits_obs: 2 (width: 1), nbits_all: 4 (width: 1)
 * reset_table: 1, trans_table: 1, input_filter: 1
 ******************************************************************************/

#include <cstdlib>
#include "monitor2.hpp"

namespace rvsynth {
using namespace std;

/* maximum number of elements in each line: 20 */
int monitor2::reset_table[8] = {
  0, 1, 1, 1, 1, 1, 1, 1
};

/* maximum number of elements in each line: 4 */
monitor2::trans_t monitor2::data_7[2] = {
  {0x1L, 2, 6}, {0x2L, 2, 7}
};

monitor2::trans_t monitor2::data_6[2] = {
  {0x1L, 2, 6}, {0x2L, 2, 7}
};

monitor2::trans_t monitor2::data_5[2] = {
  {0x1L, 2, 6}, {0x2L, 0, 3}
};

monitor2::trans_t monitor2::data_4[2] = {
  {0x1L, 2, 6}, {0x2L, 0, 5}
};

monitor2::trans_t monitor2::data_3[2] = {
  {0x1L, 0, 2}, {0x2L, 0, 3}
};

monitor2::trans_t monitor2::data_2[2] = {
  {0x1L, 0, 4}, {0x2L, 0, 5}
};

monitor2::trans_t monitor2::data_1[2] = {
  {0x1L, 0, 2}, {0x2L, 0, 3}
};

int monitor2::data_cmp (const void *lhs, const void *rhs)
{
  const trans_t *a = (const trans_t *)lhs;
  const trans_t *b = (const trans_t *)rhs;

  return (a->input - b->input);
}

monitor2::trans_t *monitor2::data_table[8] = {
  NULL, data_1, data_2, data_3, data_4, data_5, data_6, data_7
};

/* number of elements in each line: 20 */
size_t monitor2::size_table[8] = {
  0, 2, 2, 2, 2, 2, 2, 2
};

int // [out] (0 = unknown, 1 = true, 2 = false, 3 = error)
  monitor2::run
    (long state,       // [in]
     int  reset)       // [in] (0 = none, 1 = hard, 2 = soft)
{
  vector<long> states(1);
  RV_value result;
  long base = 1L;

  states[0] = (state % 2L) * base;
  state >>= 1;
  base <<= 1;
  states[0] += (state % 2L) * base;
  state >>= 1;
  base <<= 1;
  states[0] += (state % 2L) * base;
  state >>= 1;
  base <<= 1;
  states[0] += (state % 2L) * base;
  result = run(states, (RV_reset)reset);

  return (int)result;
}

RV_value monitor2::run(vector<long> &states, RV_reset reset)
{
  // local variables
  vector<long> inputs(1);
  trans_t *table, key, *result; // for bsearch()
  size_t size;                  // for bsearch()
  RV_value output;

  // handle resets
  if (HARD_RESET == reset) {
    current_loc = 1; // initial location
  }

  // validate inputs
  if (current_loc <= 0 || current_loc > 7) {
    return RV_INVALID_LOC;
  }
  if (states.size() < 1) return RV_INVALID_ARG;

  if (SOFT_RESET == reset) {
    int i = current_loc;
    current_loc = reset_table[i];
  }

  // input filtering
  {
    long state = states[0], base = 1L;
    inputs[0] = (state % 2L) * base;
    state >>= 1; base <<= 1;
    inputs[0] += (state % 2L) * base;
  }

  // perform binary search
  table = data_table[current_loc];
  size = size_table[current_loc];
  key.input = inputs[0];
  result = (trans_t *)bsearch(&key, table, size, sizeof(trans_t), data_cmp);
  if (result) {
    output = (RV_value)result->output;
    current_loc = result->next_loc;
  } else {
    output = RV_ERROR;
  }
  return output;
}

} // namespace rvsynth
