/******************************************************************************
 * monitor code generated by NuRV (version: 1.8.0)
 *
 * LTL:  G (beatMissed -> !( X beatMissed))
 *
 * nbits_obs: 2 (width: 1), nbits_all: 2 (width: 1)
 * reset_table: 1, trans_table: 1, input_filter: 1
 ******************************************************************************/

#include <stdlib.h> /* for bsearch() */
#include <string.h> /* for memset() */
#include "monitor.h"

/* maximum number of elements in each line: 20 */
static int reset_table[6] = {
  0, 1, 1, 1, 1, 1
};

/* for internal per-monitor use only */
typedef struct {
  long input;
  int output;
  int next_loc;
} trans_t;

/* maximum number of elements in each line: 4 */
static trans_t data_5[2] = {
  {0x1L, 2, 5}, {0x2L, 2, 4}
};

static trans_t data_4[2] = {
  {0x1L, 2, 5}, {0x2L, 2, 4}
};

static trans_t data_3[2] = {
  {0x1L, 0, 2}, {0x2L, 2, 4}
};

static trans_t data_2[2] = {
  {0x1L, 0, 2}, {0x2L, 0, 3}
};

static trans_t data_1[2] = {
  {0x1L, 0, 2}, {0x2L, 0, 3}
};

static int data_cmp (const void *lhs, const void *rhs)
{
  const trans_t *a = (const trans_t *)lhs;
  const trans_t *b = (const trans_t *)rhs;

  return (a->input - b->input);
}

static trans_t* data_table[6] = {
  NULL, data_1, data_2, data_3, data_4, data_5
};

/* number of elements in each line: 20 */
static size_t size_table[6] = {
  0, 2, 2, 2, 2, 2
};

/* main function (old API) */
int /* [out] (0 = unknown, 1 = true, 2 = false, 3 = error) */
  monitor
    (long state,       /* [in] */
     int  reset,       /* [in] (0 = none, 1 = hard, 2 = soft) */
     int *current_loc) /* [in/out] */
{
  long states[1], base = 1L;

  states[0] = (state % 2L) * base;
  state >>= 1;
  base <<= 1;
  states[0] += (state % 2L) * base;

  return monitor_ex (states, 1, reset, current_loc);
}

/* internal function (no input filtering) */
static RV_value monitor_internal
  (long    *inputs,      /* [in] */
   size_t   width,       /* [in] (min: 1) */
   RV_reset reset,       /* [in] */
   int     *current_loc) /* [in/out] */
{
  /* local variables */
  trans_t *table, key, *result; /* for bsearch() */
  size_t size;                  /* for bsearch() */
  RV_value output;

  /* validate inputs */
  if (NULL == current_loc || *current_loc <= 0 || *current_loc > 5) {
    return RV_INVALID_LOC;
  }
  if (width < 1) return RV_INVALID_ARG;

  /* handle resets */
  if (HARD_RESET == reset) {
    *current_loc = 1; /* initial location */
  }
  else if (SOFT_RESET == reset) {
    int i = *current_loc;
    *current_loc = reset_table[i];
  }

  /* perform binary search */
  table = data_table[*current_loc];
  size = size_table[*current_loc];
  key.input = inputs[0];
  result = (trans_t *)bsearch(&key, table, size, sizeof(trans_t), data_cmp);
  if (result) {
    output = result->output;
    *current_loc = result->next_loc;
  } else {
    output = RV_ERROR;
  }

  return output;
}

/* main function (new API) */
RV_value monitor_ex
  (long    *states,      /* [in] */
   size_t   width,       /* [in] (min: 1) */
   RV_reset reset,       /* [in] */
   int     *current_loc) /* [in/out] */
{
  long inputs[1];
  long state = states[0], base = 1L;
  inputs[0] = (state % 2L) * base;
  state >>= 1; base <<= 1;
  inputs[0] += (state % 2L) * base;

  return monitor_internal(inputs, 1, reset, current_loc);
}

/* scalar support */
typedef struct {int key; int value;} scalar_t;

static int scalar_cmp (const void *lhs, const void *rhs)
{
  const scalar_t *a = (const scalar_t *)lhs;
  const scalar_t *b = (const scalar_t *)rhs;

  return (a->key - b->key);
}

/* The scalar monitor interface */
RV_value monitor_scalar
  (monitor_input_t *input,
   monitor_mask_t *masks, /* NULL = no masks (all observable) */
   RV_reset reset,
   int *current_loc)
{
  long inputs[1];
  scalar_t item, *result;
  int beatOk = input->beatOk;
  int beatMissed = input->beatMissed;
  int bits;

  memset((void *)inputs, 0, 1 * sizeof(long));
  inputs[0] += (beatOk ? 1 : 0) * 0x1;
  inputs[0] += (beatMissed ? 1 : 0) * 0x2;

  return monitor_internal(inputs, 1, reset, current_loc);
}
