/******************************************************************************
 * monitor code generated by NuRV (version: 1.8.1)
 *
 * LTL: (i < 150 U i >= 150)
 *
 * nbits_obs: 3 (width: 1), nbits_all: 3 (width: 1)
 * reset_table: 1, trans_table: 1, input_filter: 0
 ******************************************************************************/

#include <stddef.h> /* for size_t */
#include <stdlib.h> /* for bsearch() */
#include <string.h> /* for memset() */
#include <assert.h> /* for assert() */
#include "m2.h"

/* maximum number of elements in each line: 20 */
static int reset_table[8] = {
  0, 1, 1, 1, 1, 1, 1, 1
};

/* for internal per-monitor use only */
typedef struct {
  long input;
  int output;
  int next_loc;
} trans_t;

/* maximum number of elements in each line: 4 */
static trans_t data_7[4] = {
  {0x0L, 1, 5}, {0x1L, 1, 7}, {0x4L, 1, 4}, {0x5L, 1, 6} /* L1 */
};

static trans_t data_6[4] = {
  {0x0L, 1, 5}, {0x1L, 1, 7}, {0x4L, 1, 4}, {0x5L, 1, 6} /* L1 */
};

static trans_t data_5[4] = {
  {0x0L, 1, 5}, {0x1L, 1, 7}, {0x4L, 1, 4}, {0x5L, 1, 6} /* L1 */
};

static trans_t data_4[4] = {
  {0x0L, 1, 5}, {0x1L, 1, 7}, {0x4L, 1, 4}, {0x5L, 1, 6} /* L1 */
};

static trans_t data_3[4] = {
  {0x0L, 1, 5}, {0x1L, 0, 3}, {0x4L, 1, 4}, {0x5L, 0, 2} /* L1 */
};

static trans_t data_2[4] = {
  {0x0L, 1, 5}, {0x1L, 0, 3}, {0x4L, 1, 4}, {0x5L, 0, 2} /* L1 */
};

static trans_t data_1[4] = {
  {0x0L, 1, 5}, {0x1L, 0, 3}, {0x4L, 1, 4}, {0x5L, 0, 2} /* L1 */
};

static int data_cmp (const void *lhs, const void *rhs)
{
  const trans_t *_lhs = (const trans_t *)lhs;
  const trans_t *_rhs = (const trans_t *)rhs;

  return (_lhs -> input - _rhs -> input);
}

static trans_t* data_table[8] = {
  NULL, data_1, data_2, data_3, data_4, data_5, data_6, data_7
};

/* number of elements in each line: 20 */
static size_t size_table[8] = {
  0, 4, 4, 4, 4, 4, 4, 4
};

/* internal function (no input filtering) */
static RV_value m2_internal
  (long    *inputs,      /* [in] */
   size_t   width,       /* [in] (min: 1) */
   RV_reset reset,       /* [in] */
   int     *current_loc) /* [in/out] */
{
  /* local variables */
  trans_t *table, key, *result; /* for bsearch() */
  size_t size;                  /* for bsearch() */
  RV_value output;

  /* validate inputs (part 1) */
  if (NULL == current_loc) {
    return RV_INVALID_LOC;
  }

  /* handle resets */
  if (HARD_RESET == reset) {
    *current_loc = 1; /* initial location */
  }

  /* validate inputs (part 2) */
  if (*current_loc <= 0 || *current_loc > 7) {
    return RV_INVALID_LOC;
  }
  if (width < 1) return RV_INVALID_ARG;

  if (SOFT_RESET == reset) {
    int i = *current_loc;
    *current_loc = reset_table[i];
  }

  /* perform binary search */
  table = data_table[*current_loc];
  size = size_table[*current_loc];
  if (0 == size) {
    result = NULL;
  } else {
    key.input = inputs[0];
    result = (trans_t *)bsearch(&key, table, size, sizeof(trans_t), data_cmp);
  }
  if (result) {
    output = result->output;
    *current_loc = result->next_loc;
  } else {
    output = RV_ERROR;
  }

  return output;
}

/* scalar support */
typedef struct {int key; int value;} scalar_t;

static int scalar_cmp (const void *lhs, const void *rhs)
{
  const scalar_t *_lhs = (const scalar_t *)lhs;
  const scalar_t *_rhs = (const scalar_t *)rhs;

  return (_lhs -> key - _rhs -> key);
}

static scalar_t i_map[21] = {
  {140, 0x0}, {141, 0x10}, {142, 0x8}, {143, 0x18},
  {144, 0x4}, {145, 0x14}, {146, 0xc}, {147, 0x1c},
  {148, 0x2}, {149, 0x12}, {150, 0xa}, {151, 0x1a},
  {152, 0x6}, {153, 0x16}, {154, 0xe}, {155, 0x1e},
  {156, 0x1}, {157, 0x11}, {158, 0x9}, {159, 0x19},
  {160, 0x5}
};

static scalar_t k_map[4] = {
  {0, 0x1}, {1, 0x3}, {b, 0x2}, {a, 0x0}
};

static scalar_t l_map[2] = {
  {b, 0x0}, {c, 0x1}
};

/* 5. The scalar monitor interface */
RV_value m2_scalar
  (m2_input_t *input,
   m2_mask_t *masks,
   RV_reset reset,
   int *current_loc)
{
  long inputs[1];
  scalar_t item, *result = NULL;
  int i = input->i;
  int k = input->k;
  int l = input->l;
  int bit, bits;

  memset((void *)inputs, 0, 1 * sizeof(long));
  inputs[0] += (i < 150) ? 0x1L : 0L /* 2^0 */;
  inputs[0] += (i < 100) ? 0x2L : 0L /* 2^1 */;
  inputs[0] += (k == a) ? 0x4L : 0L /* 2^2 */;

  return m2_internal(inputs, 1, reset, current_loc);
}
