/******************************************************************************
 * monitor code generated by NuRV (version: 1.9.0)
 *
 * LTL: (i < 150 U i >= 150)
 *
 * nbits_obs: 7 (width: 1), nbits_all: 7 (width: 1)
 * reset_table: 1, trans_table: 1, input_filter: 0
 ******************************************************************************/

#include <stdio.h>  /* for FILE, etc. */
#include <stddef.h> /* for size_t */
#include <stdlib.h> /* for bsearch() */
#include <string.h> /* for memset() */
#include <assert.h> /* for assert() */

#include "m1b.h"

static char *constant_table[] = {
  NULL, NULL, "b", "a", "c"
};

/* 5. The scalar monitor interface */
static NuSMVEnv_ptr m1b_env = NULL;
static RV_monitor_ptr m1b_monitor = NULL;

RV_value m1b_scalar
  (m1b_input_t *input,
   m1b_mask_t *masks,
   RV_reset reset,
   int *current_loc)
{
  char constraints[1024], temp[80];
  int i = input->i;
  int k = input->k;
  int l = input->l;
  RV_value output;

  if (NULL == m1b_monitor) {
    int status = m1b_init();
    if (status) return RV_INVALID_MON;
  }

  strcpy(constraints, "TRUE");
  strcat(constraints, " & ");
  sprintf(temp, "(i = %d)", i);
  strcat(constraints, temp);
  strcat(constraints, " & ");
  if (constant_table[k]) {
    sprintf(temp, "(k = %s)", constant_table[k]);
  } else {
    sprintf(temp, "(k = %d)", k);
  }
  strcat(constraints, temp);
  strcat(constraints, " & ");
  if (constant_table[l]) {
    sprintf(temp, "(l = %s)", constant_table[l]);
  } else {
    sprintf(temp, "(l = %d)", l);
  }
  strcat(constraints, temp);
#if DEBUG
  printf("constraints := (%s)\n", constraints);
#endif
  {
    BddEnc_ptr bdd_enc = BDD_ENC(NuSMVEnv_get_value(m1b_env, ENV_BDD_ENCODER));
    DDMgr_ptr dd = DD_MGR(NuSMVEnv_get_value(m1b_env, ENV_DD_MGR));
    bdd_ptr bdd_constraints =
      simulate_get_constraints_from_string(m1b_env, constraints, bdd_enc, false, true);
    if ((bdd_ptr) NULL == bdd_constraints) return RV_INVALID_ARG;
    if (reset) {
      RV_reset_internal(m1b_monitor, (HARD_RESET == reset));
    }
    RV_heartbeat_internal(m1b_monitor, bdd_constraints);
    bdd_free(dd, bdd_constraints);
    output = RV_output_value(m1b_monitor);
    return output;
  }
}

int m1b_init()
{
  int status;
  static char *input_file = "model1.smv";
  static char *property = "(i < 150 U i >= 150)";
  static FP_V_E iq_fns[][2] = {{NuXmv_Init, NuXmv_Quit},
                               {NuRV_Init, NuRV_Quit}};
  StreamMgr_ptr streams;
  ErrorMgr_ptr errmgr;
  OptsHandler_ptr opts;
  SymbTable_ptr symb_table;
  PropDbAccessor_ptr prop_dba;
  Prop_ptr prop;
  lsList props;
  NodeList_ptr observables;
  bdd_ptr bdd_constraints;
  int propno = 0;

  NuSMVCore_init_data();
  m1b_env = NuSMVEnv_create();
  NuSMVCore_init(m1b_env, iq_fns, sizeof(iq_fns)/sizeof(iq_fns[0]));
  streams = STREAM_MGR(NuSMVEnv_get_value(m1b_env, ENV_STREAM_MANAGER));
  errmgr = ERROR_MGR(NuSMVEnv_get_value(m1b_env, ENV_ERROR_MANAGER));
  opts = OPTS_HANDLER(NuSMVEnv_get_value(m1b_env, ENV_OPTS_HANDLER));
  symb_table = SYMB_TABLE(NuSMVEnv_get_value(m1b_env, ENV_SYMB_TABLE));
  set_verbose_level(opts, 0);
  if (cmp_struct_get_read_model(cmps) == 0) {
    if (Parser_read_model(m1b_env, input_file)) return 1;
  }
  if (cmp_struct_get_flatten_hrc(cmps) == 0) {
    if (CompileFlatten_flatten_smv(m1b_env, true)) return 1;
  }
  if (cmp_struct_get_build_flat_model(cmps) == 0) {
    if (Compile_create_flat_model(m1b_env)) return 1;
  }
  if (cmp_struct_get_encode_variables(cmps) == 0) {
    if (Compile_encode_variables(m1b_env, NIL(char), false)) return 1;
  }
  if (cmp_struct_get_build_model(cmps) == 0) {
    if (Compile_build_model(m1b_env, TRANS_TYPE_INVALID)) return 1;
  }
  prop_dba = PROP_DB_ACCESSOR(NuSMVEnv_get_value(m1b_env, ENV_PROP_DBA));
  propno = PropDbAccessor_prop_parse_and_add(prop_dba, symb_table, property,
             Prop_Ltl, Nil);
  prop = PropDbAccessor_get_prop_at_index(prop_dba, propno);
  observables = NodeList_create();
  props = lsSingleton ((lsGeneric)prop, (lsHandle *)NULL);
  bdd_constraints = (bdd_ptr) NULL;
  m1b_monitor =
    RV_build_monitor_from_props(m1b_env, props, false /* ptLTL */,
                                bdd_constraints, observables);
  return ((NULL == m1b_monitor) ? 1 : 0);
}

void m1b_deinit()
{
  NuSMVCore_quit(m1b_env);
  NuSMVEnv_destroy(m1b_env);
}
