/******************************************************************************
 * monitor code generated by NuRV (NuRV_lite version: 1.0.0)
 *
 * LTL: (p[0] U p[1])
 *
 * nbits_obs: 2 (width: 1), nbits_all: 2 (width: 1)
 * reset_table: 1, trans_table: 1, input_filter: 0
 ******************************************************************************/

#include <stdio.h>  /* for FILE, etc. */
#include <stddef.h> /* for size_t */
#include <stdlib.h> /* for bsearch() */
#include <string.h> /* for memset() */
#include <assert.h> /* for assert() */

#include "m3.h"

/* maximum number of elements in each line: 20 */
static int reset_table[11] = {
  0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
};

/* for internal per-monitor use only */
typedef struct {
  long input;
  int output;
  int next_loc;
} trans_t;

/* maximum number of elements in each line: 4 */
static trans_t data_10[4] = {
  {0x0L, 1, 9}, {0x1L, 1, 10}, {0x2L, 1, 4}, {0x3L, 1, 2} /* L1 */
};

static trans_t data_9[4] = {
  {0x0L, 1, 9}, {0x1L, 1, 10}, {0x2L, 1, 4}, {0x3L, 1, 2} /* L1 */
};

static trans_t data_8[4] = {
  {0x0L, 2, 5}, {0x1L, 2, 6}, {0x2L, 2, 7}, {0x3L, 2, 8} /* L1 */
};

static trans_t data_7[4] = {
  {0x0L, 2, 5}, {0x1L, 2, 6}, {0x2L, 2, 7}, {0x3L, 2, 8} /* L1 */
};

static trans_t data_6[4] = {
  {0x0L, 2, 5}, {0x1L, 2, 6}, {0x2L, 2, 7}, {0x3L, 2, 8} /* L1 */
};

static trans_t data_5[4] = {
  {0x0L, 2, 5}, {0x1L, 2, 6}, {0x2L, 2, 7}, {0x3L, 2, 8} /* L1 */
};

static trans_t data_4[4] = {
  {0x0L, 1, 9}, {0x1L, 1, 10}, {0x2L, 1, 4}, {0x3L, 1, 2} /* L1 */
};

static trans_t data_3[4] = {
  {0x0L, 2, 5}, {0x1L, 0, 3}, {0x2L, 1, 4}, {0x3L, 1, 2} /* L1 */
};

static trans_t data_2[4] = {
  {0x0L, 1, 9}, {0x1L, 1, 10}, {0x2L, 1, 4}, {0x3L, 1, 2} /* L1 */
};

static trans_t data_1[4] = {
  {0x0L, 2, 5}, {0x1L, 0, 3}, {0x2L, 1, 4}, {0x3L, 1, 2} /* L1 */
};

static int data_cmp (const void *lhs, const void *rhs)
{
  const trans_t *_lhs = (const trans_t *)lhs;
  const trans_t *_rhs = (const trans_t *)rhs;

  return (_lhs -> input - _rhs -> input);
}

static trans_t* data_table[11] = {
  NULL, data_1, data_2, data_3, data_4, data_5, data_6, data_7, /* L1 */
  data_8, data_9, data_10
};

/* number of elements in each line: 20 */
static size_t size_table[11] = {
  0, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4
};

/* internal function (no input filtering) */
static RV_value m3_internal
  (long    *inputs,      /* [in] */
   size_t   width,       /* [in] (min: 1) */
   RV_reset reset,       /* [in] */
   int     *current_loc) /* [in/out] */
{
  /* local variables */
  trans_t *table, key, *result; /* for bsearch() */
  size_t size;                  /* for bsearch() */
  RV_value output;

  /* validate inputs (part 1) */
  if (NULL == current_loc) {
    return RV_INVALID_LOC;
  }

  /* handle resets */
  if (HARD_RESET == reset) {
    *current_loc = 1; /* initial location */
  }

  /* validate inputs (part 2) */
  if (*current_loc <= 0 || *current_loc > 10) {
    return RV_INVALID_LOC;
  }
  if (width < 1) return RV_INVALID_ARG;

  if (SOFT_RESET == reset) {
    int i = *current_loc;
    *current_loc = reset_table[i];
  }

  /* perform binary search */
  table = data_table[*current_loc];
  size = size_table[*current_loc];
  if (0 == size) {
    result = NULL;
  } else {
    key.input = inputs[0];
    result = (trans_t *)bsearch(&key, table, size, sizeof(trans_t), data_cmp);
  }
  if (result) {
    output = result->output;
    *current_loc = result->next_loc;
  } else {
    output = RV_ERROR;
  }

  return output;
}

/* scalar support */
typedef struct {int key; int value;} scalar_t;

static int scalar_cmp (const void *lhs, const void *rhs)
{
  const scalar_t *_lhs = (const scalar_t *)lhs;
  const scalar_t *_rhs = (const scalar_t *)rhs;

  return (_lhs -> key - _rhs -> key);
}

static scalar_t q[10]_map[3] = {
  {z, 0x1}, {OK, 0x0}, {y, 0x2}
};

static scalar_t q[11]_map[3] = {
  {z, 0x1}, {OK, 0x0}, {y, 0x2}
};

/* 5. The scalar monitor interface */
RV_value m3_scalar
  (m3_input_t *input,
   m3_mask_t *masks,
   RV_reset reset,
   int *current_loc)
{
  long inputs[1];
  scalar_t item, *result = NULL;
  int *p = input->p;
  int *q = input->q;
  unsigned long long *r = input->r;
  int bit, bits;

  memset((void *)inputs, 0, 1 * sizeof(long));
  inputs[0] += (p[0]) ? 0x1L : 0L;
  inputs[0] += (p[1]) ? 0x2L : 0L;

  return m3_internal(inputs, 1, reset, current_loc);
}
